/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the EverflowConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EverflowConnectorForm{}

// EverflowConnectorForm struct for EverflowConnectorForm
type EverflowConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Label of the source
	Label string `json:"label"`
	// Report type
	ReportType string `json:"reportType"`
	// Columns
	Column []string `json:"column,omitempty"`
	// Time column
	TimeColumn *string `json:"timeColumn,omitempty"`
	// Timezone
	TimezoneId *string `json:"timezoneId,omitempty"`
	// Currency
	Currency *string `json:"currency,omitempty"`
	// Metrics
	Metric []string `json:"metric"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
}

// NewEverflowConnectorForm instantiates a new EverflowConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEverflowConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, reportType string, metric []string) *EverflowConnectorForm {
	this := EverflowConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.ReportType = reportType
	this.Metric = metric
	return &this
}

// NewEverflowConnectorFormWithDefaults instantiates a new EverflowConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEverflowConnectorFormWithDefaults() *EverflowConnectorForm {
	this := EverflowConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *EverflowConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *EverflowConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *EverflowConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *EverflowConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *EverflowConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *EverflowConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *EverflowConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *EverflowConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *EverflowConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *EverflowConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *EverflowConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *EverflowConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *EverflowConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetReportType returns the ReportType field value
func (o *EverflowConnectorForm) GetReportType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetReportTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReportType, true
}

// SetReportType sets field value
func (o *EverflowConnectorForm) SetReportType(v string) {
	o.ReportType = v
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *EverflowConnectorForm) GetColumn() []string {
	if o == nil || IsNil(o.Column) {
		var ret []string
		return ret
	}
	return o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetColumnOk() ([]string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *EverflowConnectorForm) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given []string and assigns it to the Column field.
func (o *EverflowConnectorForm) SetColumn(v []string) {
	o.Column = v
}

// GetTimeColumn returns the TimeColumn field value if set, zero value otherwise.
func (o *EverflowConnectorForm) GetTimeColumn() string {
	if o == nil || IsNil(o.TimeColumn) {
		var ret string
		return ret
	}
	return *o.TimeColumn
}

// GetTimeColumnOk returns a tuple with the TimeColumn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetTimeColumnOk() (*string, bool) {
	if o == nil || IsNil(o.TimeColumn) {
		return nil, false
	}
	return o.TimeColumn, true
}

// HasTimeColumn returns a boolean if a field has been set.
func (o *EverflowConnectorForm) HasTimeColumn() bool {
	if o != nil && !IsNil(o.TimeColumn) {
		return true
	}

	return false
}

// SetTimeColumn gets a reference to the given string and assigns it to the TimeColumn field.
func (o *EverflowConnectorForm) SetTimeColumn(v string) {
	o.TimeColumn = &v
}

// GetTimezoneId returns the TimezoneId field value if set, zero value otherwise.
func (o *EverflowConnectorForm) GetTimezoneId() string {
	if o == nil || IsNil(o.TimezoneId) {
		var ret string
		return ret
	}
	return *o.TimezoneId
}

// GetTimezoneIdOk returns a tuple with the TimezoneId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetTimezoneIdOk() (*string, bool) {
	if o == nil || IsNil(o.TimezoneId) {
		return nil, false
	}
	return o.TimezoneId, true
}

// HasTimezoneId returns a boolean if a field has been set.
func (o *EverflowConnectorForm) HasTimezoneId() bool {
	if o != nil && !IsNil(o.TimezoneId) {
		return true
	}

	return false
}

// SetTimezoneId gets a reference to the given string and assigns it to the TimezoneId field.
func (o *EverflowConnectorForm) SetTimezoneId(v string) {
	o.TimezoneId = &v
}

// GetCurrency returns the Currency field value if set, zero value otherwise.
func (o *EverflowConnectorForm) GetCurrency() string {
	if o == nil || IsNil(o.Currency) {
		var ret string
		return ret
	}
	return *o.Currency
}

// GetCurrencyOk returns a tuple with the Currency field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetCurrencyOk() (*string, bool) {
	if o == nil || IsNil(o.Currency) {
		return nil, false
	}
	return o.Currency, true
}

// HasCurrency returns a boolean if a field has been set.
func (o *EverflowConnectorForm) HasCurrency() bool {
	if o != nil && !IsNil(o.Currency) {
		return true
	}

	return false
}

// SetCurrency gets a reference to the given string and assigns it to the Currency field.
func (o *EverflowConnectorForm) SetCurrency(v string) {
	o.Currency = &v
}

// GetMetric returns the Metric field value
func (o *EverflowConnectorForm) GetMetric() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metric, true
}

// SetMetric sets field value
func (o *EverflowConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *EverflowConnectorForm) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *EverflowConnectorForm) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *EverflowConnectorForm) SetDateRange(v string) {
	o.DateRange = &v
}

func (o EverflowConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EverflowConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["reportType"] = o.ReportType
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.TimeColumn) {
		toSerialize["timeColumn"] = o.TimeColumn
	}
	if !IsNil(o.TimezoneId) {
		toSerialize["timezoneId"] = o.TimezoneId
	}
	if !IsNil(o.Currency) {
		toSerialize["currency"] = o.Currency
	}
	toSerialize["metric"] = o.Metric
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableEverflowConnectorForm struct {
	value *EverflowConnectorForm
	isSet bool
}

func (v NullableEverflowConnectorForm) Get() *EverflowConnectorForm {
	return v.value
}

func (v *NullableEverflowConnectorForm) Set(val *EverflowConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableEverflowConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableEverflowConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEverflowConnectorForm(val *EverflowConnectorForm) *NullableEverflowConnectorForm {
	return &NullableEverflowConnectorForm{value: val, isSet: true}
}

func (v NullableEverflowConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEverflowConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
